package RPM::Source::Tools::LoadFlag;

use strict;
use warnings;
use Exporter 'import';
our @EXPORT_OK = qw(read_list_as_flaghash read_list_as_arrayhash read_list_as_one2one);  # symbols to export on request

sub read_list_as_flaghash {
    my ($flag, @files)=@_;
    foreach my $f (@files) {
	open(F, $f) || die "read_list_as_flaghash: $! [$f].";
	local $_;
	while (<F>) {
	    chomp;
	    s,^\s*,,;
	    # comments and so on
	    s,\s+.*$,,;
	    s,#.*$,,;
	    next if not $_ or /^#/;
	    $flag->{$_}=1;
	}
	close(F);
    }
}

sub read_list_as_arrayhash {
    my ($flag, @files)=@_;
    foreach my $f (@files) {
	open(F, $f) || die "read_list_as_flaghash: $! [$f].";
	local $_;
	while (<F>) {
	    chomp;
	    s,^\s*,,;
	    s,\s*$,,;
	    next if not $_ or /^#/;
	    my @data=split(/\s+/,$_);
	    $flag->{shift @data}=\@data;
	}
	close(F);
    }
}

sub read_list_as_one2one {
    my ($flag, @files)=@_;
    foreach my $f (@files) {
	open(F, $f) || die "read_list_as_one2one: $! [$f].";
	local $_;
	while (<F>) {
	    chomp;
	    s,^\s*,,;
	    s,\s*$,,;
	    next if not $_ or /^#/;
	    die "invalid input for read_list_as_one2one: $_" if not s/^(\S+)\s+//;
	    $flag->{$1}=$_;
	}
	close(F);
    }
}

1;
