package RPM::Source::Tools::RPM2CpioUnpack;

use strict;
use warnings;

use Exporter 'import';
our @EXPORT_OK = qw(rpm2cpio_unpack1 rpm2cpio_unpack2 rpm2cpio_fakeroot_unpack2);
our $VERSION='0.001';

my ($cpio_unpack_cmd,@cpio_unpack_cmd);
&init_unpack_method();

sub init_unpack_method {
    @cpio_unpack_cmd=qw!cpio -idmu --quiet --force-local --no-absolute-filenames!;

    # pax is preferred over cpio due to correct unpacking for unreadable directories
    # do not use pax for autoimports; it fails on some rpm2cpio archives,
    # see perl-TinkerForge-debuginfo-0.01-alt6.x86_64.rpm
    # in repocop.git/TODO.pax
    #if (0 and -x '/usr/bin/pax') {
    if (-x '/usr/bin/pax' and not $ENV{'RPM2CPIOUNPACK_NO_USE_PAX'}) {
	#debug("Note: pax found. using pax.");
	@cpio_unpack_cmd=qw!pax -O -r!;
    }
    $cpio_unpack_cmd=join(' ',@cpio_unpack_cmd);
}

sub rpm2cpio_unpack1 {
    my ($rpm)=@_;
    return 0==system("rpm2cpio '$rpm' | $cpio_unpack_cmd");
}

sub rpm2cpio_unpack2 {
    my ($rpm,$unpack_files_ref)=@_;
    unless ($unpack_files_ref) {
	return 0==system("rpm2cpio '$rpm' | $cpio_unpack_cmd");
    } else {
	return 0==system("rpm2cpio '$rpm' | $cpio_unpack_cmd '".join("' '",@$unpack_files_ref)."'");
    }
}

sub rpm2cpio_fakeroot_unpack2 {
    my ($rpm,$fakedata)=@_;
    $fakedata //= '../.fakedata';
    return 0==system("rpm2cpio '$rpm' | fakeroot -s $fakedata -- $cpio_unpack_cmd");
}

1;
