package RPM::Source::Transform;

use strict;
use warnings;

use Carp;
use RPM::Source::Transformation::CoreTransformationSet;
use Source::Shared::CLI;
our @ISA=qw/Source::Shared::CLI/;

our $VERSION=0.021;

sub cli_container_ref { return ['RPM::Source::TransformContainer'] }

sub new {
    my $class = shift;
    my $self = {
	@_
    };
    bless $self, $class;
    $self->get_and_process_cli_options();
    RPM::Source::TransformContainer->init_transformations();

    if (!$RPM::Source::TransformContainer::INPUT_HANDLER) {
	die "ERROR: INTERNAL: INPUT_HANDLER is missing";
    }
    $RPM::Source::TransformContainer::INPUT_HANDLER->process_args();
    if (not $RPM::Source::TransformContainer::INPUT_HANDLER->verify_args()) {
	print STDERR "ERROR: invalid or missing input arguments.\n";
	exit(4);
    }
    return $self;
}

1;
