package RPM::Source::Transformation::Factory::Gear2Git;

# WARNING: code is SRPM-only, can't be used under gear
# (where patches might exist only potentially, as a .gear/rule)

# TODO: RaiseRelease has the same functionality.
# TODO: merge or check && drop

use strict;
use warnings;

use RPM::Source::Transformation::Factory;
our @ISA=qw/RPM::Source::Transformation::Factory/;
push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

# $verbose=0;

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	-priority => PRIORITY_SRPM_AT_BEGIN,
	-name => 'bundle update srpm hack version in patch names',
	-opt_handler_sub=>\&opt_handler_hack_version_in_patches);
}

sub opt_handler_hack_version_in_patches {
    my (undef,$spec,undef,$converter_opt,$resourceobj)=@_;
    # DO not run in GEAR mode.
    return RPM::Source::TransformContainer::TRANSFORMATION_OK if $spec->{GEARDIR};
    my (undef,undef,$oldver,$oldrel)=$spec->_get_nevr();
    my $mainsec=$spec->main_section;
    $mainsec->map_body(sub {s/\%\{?version\}?/$oldver/,s/\%\{?release\}?/$oldrel/, if /^Patch/});
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}

1;
