package RPM::Source::Transformation::Factory::ParentUrlMerge;

use strict;
use warnings;

use Source::Shared::Resource::Verbose;
use RPM::Source::Transformation::Factory;
use RPM::Source::Transformation::OptHandlerWrapper;
our @ISA=qw/RPM::Source::Transformation::Factory/;

push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	    # after PRIORITY_COMMANDLINE (--url cmdline option)
	    -priority => PRIORITY_DEFAULT,
	    -name => 'merge parent Url',
	    -opt_handler_sub=>\&opt_handler_merge_parent_url);
}

sub opt_handler_merge_parent_url {
    my (undef,$spec,$parent,$opt,$resourceobj)=@_;
    my $mainsec=$spec->main_section;
    my $url=$mainsec->get_tag('Url', RAW=>1);
    unless (defined $url) {
	if ($parent) {
	    $url=$parent->main_section->get_tag('Url', RAW=>0);
	    if ($url) {
		$mainsec->set_tag('Url',$url);
		print STDERR "info: merged Url: from parent.\n" if $Source::Shared::verbose>1;
	    }
	}
	unless (defined $url) {
	    print STDERR "WARN: RPM tag Url: not found.\n" if $Source::Shared::verbose;
	}
    }
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}

1;
