package RPM::Source::Transformation::PkgWriter;

use strict;
use warnings;
use RPM::Source::Transformation::Writer::Basic;
use RPM::Source::Transformation::Component;
our @ISA=qw/RPM::Source::Transformation::Component/;
$RPM::Source::TransformContainer::WRITER=__PACKAGE__;

# no need; right here Writer::Basic registers itself as SUPPORT_CLASSES
#push @RPM::Source::TransformContainer::SUPPORT_CLASSES, @{&cli_container_ref()};
#sub cli_container_ref { return ['RPM::Source::Transformation::Writer::Basic']; }

our $verbose=1;
my $opt_transaction_output_subdir;
our $outputdir;

sub print_longopt {
    print "
  Output options:
	--outdir /path/to/output_dir (default is ".($outputdir ? $outputdir:'.').")
";
}
#	--transaction-output-subdir 'subpath' 

our @LONGOPT=(
    'out|outdir=s' => \$outputdir,
    'transaction-output-subdir=s'	=> \$opt_transaction_output_subdir,
);

sub register_messages {
    my ($self,$extopt)=@_;
    RPM::Source::Transformation::Component::add_opt($extopt, {
	-outputdir => $outputdir,
	-transaction_output_subdir => $opt_transaction_output_subdir,
    });
}

sub write {
    my (undef,$spec,$parent,$opt,$resourceobj)=@_;
    my $outdir=$opt->{-outputdir};
    my $subdir=$opt->{-transaction_output_subdir};
    if ($subdir) {
	if ($outdir) {
	    $outdir.='/'.$subdir;
	} else {
	    $outdir=$subdir;
	}
    }
    $opt->{-output_srpm_dir}//=$outdir if $outdir;
    return RPM::Source::Transformation::Writer::Basic->write($spec,$parent,$opt,$resourceobj);
}

1;

__END__
