# TODO: make it EarlyResource?
package RPM::Source::Transformation::Resource::Buildreq;

use strict;
use warnings;
use Carp;
use Data::Dumper;

use RPM::Source::Tools::BuildReqStorage;
use RPM::Source::Transformation::Resource;
our @ISA=qw/RPM::Source::Transformation::Resource/;

our $verbose=0;

push @RPM::Source::TransformContainer::RESOURCE_CLASSES, __PACKAGE__;

sub prepare_resource {
    my (undef,undef,undef,undef,$resourceobj)=@_;
    if ($resourceobj->{'__buildreq'}) {
	print STDERR "Oops! internal error: buildreq resource already exist - destroyed\n";
	print STDERR Data::Dumper::Dumper($resourceobj->{'__buildreq'}),"\n";
	# to destroy
	$resourceobj->{'__buildreq'}=undef;
    } else {
	print STDERR "DEBUG: buildreq prepared. resourceobj=".ref($resourceobj),"\n" if $verbose>1;
    }
}

sub destroy_resource {
    my (undef,undef,undef,undef,$resourceobj)=@_;
    $resourceobj->{'__buildreq'}=undef;
    print STDERR "DEBUG: buildreq: destroyed\n" if $verbose>1;
}

package Source::Shared::ResourceContainer;

sub buildreq {
    my ($self)=@_;
    my $buildreq=$self->{'__buildreq'};
    return $buildreq if $buildreq;
    $self->{'__buildreq'}=RPM::Source::Tools::BuildReqStorage->new();
    print STDERR "DEBUG: buildreq: created buildreq\n" if $RPM::Source::Transformation::Resource::Buildreq::verbose>1;
    return $self->{'__buildreq'};
}

1;
